Bug 415511 - Forgotten macro-wrapper crashes
Forgotten macro-wrapper crashes
Product: Fedora
Classification: Fedora
Component: libunwind (Show other bugs)
All Linux
low Severity low
: ---
: ---
Assigned To: Jan Kratochvil
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2007-12-07 06:20 EST by Jan Kratochvil
Modified: 2009-07-14 11:27 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2009-07-14 11:27:36 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Forgotten UNW_OBJ() demonstration. (524 bytes, patch)
2007-12-07 06:20 EST, Jan Kratochvil
no flags Details | Diff

  None (edit)
Description Jan Kratochvil 2007-12-07 06:20:31 EST
Description of problem:
If you forget to wrap some function of the dual-built (_local/_generic) sources
by UNW_OBJ() the code has hard to reproduce crashes.

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
1. Apply the attached patch.
2. make check

Actual results:
-PASS: test-static-link
+/bin/sh: line 4: 17625 Segmentation fault      ${dir}$tst
+FAIL: test-static-link
-PASS: Gtest-bt
+/bin/sh: line 4: 17633 Segmentation fault      ${dir}$tst
+FAIL: Gtest-bt
-5 of 24 tests failed
+7 of 24 tests failed

Expected results:
Compilation error or some other sanity check.

Additional info:
$ nm `find -name "*.o"`|perl -ne 'chomp;/:$/?$p=$_:print "$p$_\n"'|grep ' T
./src/dwarf/Gstep.o:00000000000003a3 T dwarf_step
./src/dwarf/Lstep.o:0000000000000245 T dwarf_step

The problem is the linker will silently link only with the first function found
and it will ignore the remaining global definitions of the functions.

There should be implemented into the libunwind build framework a sanity check
for duplicite symbols during linking.

This is not easy to debug as it is all heavily macroized and built from the same
source files (debugging gets hopefully more manageable now with the recent F9
GDB featuring the multi-PC source lines functionality).
Comment 1 Jan Kratochvil 2007-12-07 06:20:31 EST
Created attachment 280911 [details]
Forgotten UNW_OBJ() demonstration.
Comment 2 Bug Zapper 2008-05-14 00:07:01 EDT
Changing version to '9' as part of upcoming Fedora 9 GA.
More information and reason for this action is here:
Comment 3 Bug Zapper 2009-06-09 19:15:38 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
Comment 4 Bug Zapper 2009-07-14 11:27:36 EDT
Fedora 9 changed to end-of-life (EOL) status on 2009-07-10. Fedora 9 is 
no longer maintained, which means that it will not receive any further 
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of 
Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.